import processing.sound.*;

ArrayList rings;

float speed;

int duration = 500;
int now;

float globalShake, globalShakeTarget;
float easing = 0.1;

float globalVolume;

AudioIn input;
Amplitude rms;

void setup() {
  
  size(800,500);
 // blendMode(ADD);
  
  rings= new ArrayList();
  speed = 10;
  now = millis();
  
  input = new AudioIn(this, 0);
  input.start();
  rms = new Amplitude(this);
  rms.input(input);
  
  noFill();
  
}

void draw() {
  
  background(0);
  
  
  globalShakeTarget = int(map(rms.analyze(), 0, 1, 0, 400));
  globalShake += (globalShakeTarget-globalShake)*easing;
    
  for (int i=rings.size()-1; i>= 0; i--) {
    
    Ring temp = (Ring) rings.get(i);
    temp.draw();
    temp.update();
    
    if (temp.isFinished()) rings.remove(i);
    
  }
  
  if (millis()-now > duration) {
    rings.add(new Ring(mouseX, mouseY));
    now = millis();
  }
  
  globalVolume = int(map(rms.analyze(), 0, 1, 0, 100));
  if (globalVolume > 2) duration-=6;
  else {
    if (duration < 500) duration+=4;
  }

  println(rings.size());
      
}